package com.app.kemenhub.jakbanapps.db;

import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;
import android.database.sqlite.SQLiteStatement;

import de.greenrobot.dao.AbstractDao;
import de.greenrobot.dao.Property;
import de.greenrobot.dao.internal.DaoConfig;

import com.app.kemenhub.jakbanapps.db.schedule;

// THIS CODE IS GENERATED BY greenDAO, DO NOT EDIT.
/** 
 * DAO for table "SCHEDULE".
*/
public class scheduleDao extends AbstractDao<schedule, Long> {

    public static final String TABLENAME = "SCHEDULE";

    /**
     * Properties of entity schedule.<br/>
     * Can be used for QueryBuilder and for referencing column names.
    */
    public static class Properties {
        public final static Property Id = new Property(0, Long.class, "id", true, "_id");
        public final static Property Category_id = new Property(1, String.class, "category_id", false, "CATEGORY_ID");
        public final static Property From = new Property(2, String.class, "from", false, "FROM");
        public final static Property Title = new Property(3, String.class, "title", false, "TITLE");
        public final static Property Datetime_schedule_start = new Property(4, String.class, "datetime_schedule_start", false, "DATETIME_SCHEDULE_START");
        public final static Property Datetime_schedule_end = new Property(5, String.class, "datetime_schedule_end", false, "DATETIME_SCHEDULE_END");
        public final static Property Tgl_diterima = new Property(6, String.class, "tgl_diterima", false, "TGL_DITERIMA");
        public final static Property No_surat_perintah = new Property(7, String.class, "no_surat_perintah", false, "NO_SURAT_PERINTAH");
        public final static Property No_agenda = new Property(8, String.class, "no_agenda", false, "NO_AGENDA");
        public final static Property Place = new Property(9, String.class, "place", false, "PLACE");
        public final static Property Desc = new Property(10, String.class, "desc", false, "DESC");
        public final static Property Notes = new Property(11, String.class, "notes", false, "NOTES");
        public final static Property Forward_to_user_id = new Property(12, String.class, "forward_to_user_id", false, "FORWARD_TO_USER_ID");
        public final static Property Cls = new Property(13, String.class, "cls", false, "CLS");
        public final static Property File = new Property(14, String.class, "file", false, "FILE");
        public final static Property Notif = new Property(15, Boolean.class, "notif", false, "NOTIF");
    };


    public scheduleDao(DaoConfig config) {
        super(config);
    }
    
    public scheduleDao(DaoConfig config, DaoSession daoSession) {
        super(config, daoSession);
    }

    /** Creates the underlying database table. */
    public static void createTable(SQLiteDatabase db, boolean ifNotExists) {
        String constraint = ifNotExists? "IF NOT EXISTS ": "";
        db.execSQL("CREATE TABLE " + constraint + "\"SCHEDULE\" (" + //
                "\"_id\" INTEGER PRIMARY KEY ," + // 0: id
                "\"CATEGORY_ID\" TEXT," + // 1: category_id
                "\"FROM\" TEXT," + // 2: from
                "\"TITLE\" TEXT," + // 3: title
                "\"DATETIME_SCHEDULE_START\" TEXT," + // 4: datetime_schedule_start
                "\"DATETIME_SCHEDULE_END\" TEXT," + // 5: datetime_schedule_end
                "\"TGL_DITERIMA\" TEXT," + // 6: tgl_diterima
                "\"NO_SURAT_PERINTAH\" TEXT," + // 7: no_surat_perintah
                "\"NO_AGENDA\" TEXT," + // 8: no_agenda
                "\"PLACE\" TEXT," + // 9: place
                "\"DESC\" TEXT," + // 10: desc
                "\"NOTES\" TEXT," + // 11: notes
                "\"FORWARD_TO_USER_ID\" TEXT," + // 12: forward_to_user_id
                "\"CLS\" TEXT," + // 13: cls
                "\"FILE\" TEXT," + // 14: file
                "\"NOTIF\" INTEGER);"); // 15: notif
    }

    /** Drops the underlying database table. */
    public static void dropTable(SQLiteDatabase db, boolean ifExists) {
        String sql = "DROP TABLE " + (ifExists ? "IF EXISTS " : "") + "\"SCHEDULE\"";
        db.execSQL(sql);
    }

    /** @inheritdoc */
    @Override
    protected void bindValues(SQLiteStatement stmt, schedule entity) {
        stmt.clearBindings();
 
        Long id = entity.getId();
        if (id != null) {
            stmt.bindLong(1, id);
        }
 
        String category_id = entity.getCategory_id();
        if (category_id != null) {
            stmt.bindString(2, category_id);
        }
 
        String from = entity.getFrom();
        if (from != null) {
            stmt.bindString(3, from);
        }
 
        String title = entity.getTitle();
        if (title != null) {
            stmt.bindString(4, title);
        }
 
        String datetime_schedule_start = entity.getDatetime_schedule_start();
        if (datetime_schedule_start != null) {
            stmt.bindString(5, datetime_schedule_start);
        }
 
        String datetime_schedule_end = entity.getDatetime_schedule_end();
        if (datetime_schedule_end != null) {
            stmt.bindString(6, datetime_schedule_end);
        }
 
        String tgl_diterima = entity.getTgl_diterima();
        if (tgl_diterima != null) {
            stmt.bindString(7, tgl_diterima);
        }
 
        String no_surat_perintah = entity.getNo_surat_perintah();
        if (no_surat_perintah != null) {
            stmt.bindString(8, no_surat_perintah);
        }
 
        String no_agenda = entity.getNo_agenda();
        if (no_agenda != null) {
            stmt.bindString(9, no_agenda);
        }
 
        String place = entity.getPlace();
        if (place != null) {
            stmt.bindString(10, place);
        }
 
        String desc = entity.getDesc();
        if (desc != null) {
            stmt.bindString(11, desc);
        }
 
        String notes = entity.getNotes();
        if (notes != null) {
            stmt.bindString(12, notes);
        }
 
        String forward_to_user_id = entity.getForward_to_user_id();
        if (forward_to_user_id != null) {
            stmt.bindString(13, forward_to_user_id);
        }
 
        String cls = entity.getCls();
        if (cls != null) {
            stmt.bindString(14, cls);
        }
 
        String file = entity.getFile();
        if (file != null) {
            stmt.bindString(15, file);
        }
 
        Boolean notif = entity.getNotif();
        if (notif != null) {
            stmt.bindLong(16, notif ? 1L: 0L);
        }
    }

    /** @inheritdoc */
    @Override
    public Long readKey(Cursor cursor, int offset) {
        return cursor.isNull(offset + 0) ? null : cursor.getLong(offset + 0);
    }    

    /** @inheritdoc */
    @Override
    public schedule readEntity(Cursor cursor, int offset) {
        schedule entity = new schedule( //
            cursor.isNull(offset + 0) ? null : cursor.getLong(offset + 0), // id
            cursor.isNull(offset + 1) ? null : cursor.getString(offset + 1), // category_id
            cursor.isNull(offset + 2) ? null : cursor.getString(offset + 2), // from
            cursor.isNull(offset + 3) ? null : cursor.getString(offset + 3), // title
            cursor.isNull(offset + 4) ? null : cursor.getString(offset + 4), // datetime_schedule_start
            cursor.isNull(offset + 5) ? null : cursor.getString(offset + 5), // datetime_schedule_end
            cursor.isNull(offset + 6) ? null : cursor.getString(offset + 6), // tgl_diterima
            cursor.isNull(offset + 7) ? null : cursor.getString(offset + 7), // no_surat_perintah
            cursor.isNull(offset + 8) ? null : cursor.getString(offset + 8), // no_agenda
            cursor.isNull(offset + 9) ? null : cursor.getString(offset + 9), // place
            cursor.isNull(offset + 10) ? null : cursor.getString(offset + 10), // desc
            cursor.isNull(offset + 11) ? null : cursor.getString(offset + 11), // notes
            cursor.isNull(offset + 12) ? null : cursor.getString(offset + 12), // forward_to_user_id
            cursor.isNull(offset + 13) ? null : cursor.getString(offset + 13), // cls
            cursor.isNull(offset + 14) ? null : cursor.getString(offset + 14), // file
            cursor.isNull(offset + 15) ? null : cursor.getShort(offset + 15) != 0 // notif
        );
        return entity;
    }
     
    /** @inheritdoc */
    @Override
    public void readEntity(Cursor cursor, schedule entity, int offset) {
        entity.setId(cursor.isNull(offset + 0) ? null : cursor.getLong(offset + 0));
        entity.setCategory_id(cursor.isNull(offset + 1) ? null : cursor.getString(offset + 1));
        entity.setFrom(cursor.isNull(offset + 2) ? null : cursor.getString(offset + 2));
        entity.setTitle(cursor.isNull(offset + 3) ? null : cursor.getString(offset + 3));
        entity.setDatetime_schedule_start(cursor.isNull(offset + 4) ? null : cursor.getString(offset + 4));
        entity.setDatetime_schedule_end(cursor.isNull(offset + 5) ? null : cursor.getString(offset + 5));
        entity.setTgl_diterima(cursor.isNull(offset + 6) ? null : cursor.getString(offset + 6));
        entity.setNo_surat_perintah(cursor.isNull(offset + 7) ? null : cursor.getString(offset + 7));
        entity.setNo_agenda(cursor.isNull(offset + 8) ? null : cursor.getString(offset + 8));
        entity.setPlace(cursor.isNull(offset + 9) ? null : cursor.getString(offset + 9));
        entity.setDesc(cursor.isNull(offset + 10) ? null : cursor.getString(offset + 10));
        entity.setNotes(cursor.isNull(offset + 11) ? null : cursor.getString(offset + 11));
        entity.setForward_to_user_id(cursor.isNull(offset + 12) ? null : cursor.getString(offset + 12));
        entity.setCls(cursor.isNull(offset + 13) ? null : cursor.getString(offset + 13));
        entity.setFile(cursor.isNull(offset + 14) ? null : cursor.getString(offset + 14));
        entity.setNotif(cursor.isNull(offset + 15) ? null : cursor.getShort(offset + 15) != 0);
     }
    
    /** @inheritdoc */
    @Override
    protected Long updateKeyAfterInsert(schedule entity, long rowId) {
        entity.setId(rowId);
        return rowId;
    }
    
    /** @inheritdoc */
    @Override
    public Long getKey(schedule entity) {
        if(entity != null) {
            return entity.getId();
        } else {
            return null;
        }
    }

    /** @inheritdoc */
    @Override    
    protected boolean isEntityUpdateable() {
        return true;
    }
    
}
